VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmObround 
   Caption         =   "Obrounds   By KWiK"
   ClientHeight    =   3465
   ClientLeft      =   30
   ClientTop       =   270
   ClientWidth     =   3315
   OleObjectBlob   =   "frmObround.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmObround"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub optVertical_Click()

    If optVertical.Value = True Then
        txtAngle.Enabled = False
        lblAngle.Enabled = False
    End If

End Sub

Private Sub optHorizontal_Click()

    If optHorizontal.Value = True Then
        txtAngle.Enabled = False
        lblAngle.Enabled = False
    End If

End Sub

Private Sub optAngle_Click()

    If optAngle.Value = True Then
        txtAngle.Enabled = True
        lblAngle.Enabled = True
    End If

End Sub

Private Sub cmdDone_Click()

    SaveSetting "KWiK-Obround", "Settings", "Punch", Me.optPunch.Value
    SaveSetting "KWiK-Obround", "Settings", "Dim", Me.chkDim.Value
    SaveSetting "KWiK-Obround", "Settings", "Angle", Me.txtAngle.Text
    SaveSetting "KWiK-Obround", "Settings", "Diameter", Me.txtDia.Text
    SaveSetting "KWiK-Obround", "Settings", "Length", Me.txtLong.Text
    SaveSetting "KWiK-Obround", "Settings", "Horizontal", Me.optHorizontal.Value
    SaveSetting "KWiK-Obround", "Settings", "Vertical", Me.optVertical.Value
    SaveSetting "KWiK-Obround", "Settings", "Left", Me.Left
    SaveSetting "KWiK-Obround", "Settings", "Top", Me.Top
    End

End Sub

Private Sub cmdCreate_Click()

    Dim oApp As Application
    Set oApp = ThisApplication
    Dim odoc As Document
    Set odoc = oApp.ActiveDocument
    Dim oSketch As PlanarSketch
    Set oSketch = oApp.ActiveEditObject

    
    Dim oTrans As Transaction
    Set oTrans = ThisApplication.TransactionManager.StartTransaction( _
                                            ThisApplication.ActiveDocument, _
                                            "Obround")
    Dim oUOM As UnitsOfMeasure
     Set oUOM = ThisApplication.ActiveDocument.UnitsOfMeasure
    
     Dim oArcs(1 To 2) As SketchArc
     Dim olines() As SketchLine
     Dim oCenterPt As SketchPoint
     Dim dLength, dDiameter, dAngle As Double
     Dim oPoint(1 To 3) As Point2d
     Dim i As Integer
     ' Setup number of lines for Punch or Mill and angle
     If Me.optPunch.Value = True Then
         If optAngle.Value = True Then
             ReDim olines(1 To 5)
         Else
             ReDim olines(1 To 4)
         End If
         
         Dim dDia, dLong As Double
         dDia = oUOM.GetValueFromExpression(Me.txtDia, kDefaultDisplayLengthUnits)
         dLong = oUOM.GetValueFromExpression(Me.txtLong, kDefaultDisplayLengthUnits)
        dLength = dLong - dDia
     Else
         If optAngle.Value = True Then
             ReDim olines(1 To 3)
         Else
             ReDim olines(1 To 2)
         End If
       dLength = oUOM.GetValueFromExpression(Me.txtLong, kDefaultDisplayLengthUnits)
    End If
   
   
   ' convert entered value to proper units
    dDiameter = oUOM.GetValueFromExpression(Me.txtDia, kDefaultDisplayLengthUnits)
    If optAngle.Value = True Then
        dAngle = oUOM.GetValueFromExpression(Me.txtAngle, kDefaultDisplayAngleUnits)
    End If
   ' Draw the lines and arcs that make up the shape of the slot.
    With oApp.TransientGeometry
        Set olines(1) = oSketch.SketchLines.AddByTwoPoints( _
              .CreatePoint2d(0, 0), .CreatePoint2d(dLength, 0))
        Set oArcs(1) = oSketch.SketchArcs.AddByCenterStartEndPoint( _
              .CreatePoint2d(dLength, (dDiameter / 2)), olines(1).EndSketchPoint, _
              .CreatePoint2d(dLength, dDiameter))
        Set olines(2) = oSketch.SketchLines.AddByTwoPoints( _
              oArcs(1).EndSketchPoint, .CreatePoint2d(0, dDiameter))
        Set oArcs(2) = oSketch.SketchArcs.AddByCenterStartEndPoint( _
              .CreatePoint2d(0, (dDiameter / 2)), olines(2).EndSketchPoint, _
              olines(1).StartSketchPoint)
        With oSketch.GeometricConstraints
' Create the tangent constraints between the lines and arcs.
            Call .AddTangent(olines(1), oArcs(1))
            Call .AddTangent(olines(2), oArcs(1))
            Call .AddTangent(olines(2), oArcs(2))
            Call .AddTangent(olines(1), oArcs(2))
' Create Parallel constraint between lines
            Call .AddParallel(olines(1), olines(2))
        End With
            
' if punch add construction lines
        If optPunch.Value = True Then
' Draw Length Construction line
            Set olines(3) = oSketch.SketchLines.AddByTwoPoints( _
                  .CreatePoint2d(-(dDiameter / 2), (dDiameter / 2)), _
                  .CreatePoint2d((dLength + (dDiameter / 2)), (dDiameter / 2)))
                  olines(3).Construction = True
' Draw Width Construction line
            Set olines(4) = oSketch.SketchLines.AddByTwoPoints( _
                  .CreatePoint2d(dLength / 2, 0), _
                  .CreatePoint2d(dLength / 2, dDiameter))
                  olines(4).Construction = True
            Set oCenterPt = oSketch.SketchPoints.Add(.CreatePoint2d(dLength / 2, dDiameter / 2))
            With oSketch.GeometricConstraints
' Create coincident constraints on Length Construction line, and Arcs and one Arc center
                Call .AddCoincident(olines(3).StartSketchPoint, oArcs(2))
                Call .AddCoincident(olines(3).EndSketchPoint, oArcs(1))
                Call .AddCoincident(olines(3), oArcs(2).CenterSketchPoint)
' Create Parallell constraints between length line and First line
                Call .AddParallel(olines(1), olines(3))
' Create mid constraints at ends of vertical construction line
                Call .AddMidpoint(olines(4).StartSketchPoint, olines(1))
                Call .AddMidpoint(olines(4).EndSketchPoint, olines(2))
                Call .AddCoincident(olines(4), oCenterPt)
                Call .AddCoincident(olines(3), oCenterPt)
                
            End With
               
            If optAngle.Value = True Then
' Draw Horizontal construction line
                Set olines(5) = oSketch.SketchLines.AddByTwoPoints( _
                    .CreatePoint2d(dLength / 2, dDiameter / 2), _
                    .CreatePoint2d(dLength / 2 + dDiameter, dDiameter / 2))
                    olines(5).Construction = True
' Creat Horizontal Constraint on angle baseline
                Call oSketch.GeometricConstraints.AddHorizontal(olines(5))
' Create mid constraint at end of angle construction line
                Call oSketch.GeometricConstraints.AddMidpoint( _
                   olines(5).StartSketchPoint, olines(4))
' add equal constraint to Angle Construction line so we will only be missing locating dimensions when done.
                Call oSketch.GeometricConstraints.AddEqualLength(olines(4), olines(5))
            End If
' Else if Mill
        Else
            If optAngle.Value = True Then
                Set olines(3) = oSketch.SketchLines.AddByTwoPoints( _
                    oArcs(2).CenterSketchPoint, .CreatePoint2d(dLength / 2, dDiameter / 2)) 'oArcs(1).CenterSketchPoint)
                    olines(3).Construction = True
                    Call oSketch.GeometricConstraints.AddHorizontal(olines(3))
            End If
        End If
    End With
' if horizontal or vertical add appropriate constraint.
    With oSketch.GeometricConstraints
        If Me.optHorizontal.Value = True Then
            Call .AddHorizontal(olines(1))
        End If
        If Me.optVertical.Value = True Then
            Call .AddVertical(olines(1))
        End If
    End With
    
' Set up Dimension Text placement points
    If Me.chkDim.Value = True Then
        Set oPoint(1) = oApp.TransientGeometry.CreatePoint2d(-(dDiameter * 2), dDiameter * 0.75)
        Set oPoint(2) = oApp.TransientGeometry.CreatePoint2d(dLength / 2, dDiameter * 2)
      ' Add Dimeter dimension
        Call oSketch.DimensionConstraints.AddDiameter( _
                oArcs(2), oPoint(1), False)
        If Me.optPunch.Value = True Then
            ' Add Length Dimension
            Call oSketch.DimensionConstraints.AddTwoPointDistance( _
                olines(3).StartSketchPoint, olines(3).EndSketchPoint, _
                kAlignedDim, oPoint(2), False)
        Else
            Call oSketch.DimensionConstraints.AddTwoPointDistance( _
                oArcs(1).CenterSketchPoint, oArcs(2).CenterSketchPoint, _
                kAlignedDim, oPoint(2), False)
        End If
    End If
    
    If Me.txtAngle.Enabled = True Then
          Set oPoint(3) = oApp.TransientGeometry.CreatePoint2d( _
          dLength + dDiameter, -dDiameter) '* 0.75
       ' Add Angle Dimension
        If optPunch.Value = True Then
            Call oSketch.DimensionConstraints.AddThreePointAngle( _
                  olines(3).StartSketchPoint, olines(5).StartSketchPoint, _
                  olines(5).EndSketchPoint, oPoint(3), False)
        i = oSketch.DimensionConstraints.Count
        oSketch.DimensionConstraints.Item(i).Parameter.Value = dAngle
        Else
            Call oSketch.DimensionConstraints.AddThreePointAngle( _
                    oArcs(1).CenterSketchPoint, oArcs(2).CenterSketchPoint, _
                    olines(3).EndSketchPoint, oPoint(3), False)
            i = oSketch.DimensionConstraints.Count
            oSketch.DimensionConstraints.Item(i).Parameter.Value = dAngle
        End If
    End If
      
    ThisApplication.TransactionManager.EndTransaction
    Call ThisApplication.ActiveDocument.Update

End Sub

Private Sub UserForm_Initialize()

    Me.optPunch.Value = GetSetting("KWiK-Obround", "Settings", "Punch", True)
        If optPunch.Value = False Then optMill.Value = True
    
    Me.chkDim.Value = GetSetting("KWiK-Obround", "Settings", "Dim", True)
    Me.txtAngle.Text = GetSetting("KWiK-Obround", "Settings", "Angle", "0")
    Me.txtDia.Text = GetSetting("KWiK-Obround", "Settings", "Diameter", "1")
    Me.txtLong.Text = GetSetting("KWiK-Obround", "Settings", "Length", "3")
    Me.optHorizontal.Value = GetSetting("KWiK-Obround", "Settings", "Horizontal", False)
    Me.optVertical.Value = GetSetting("KWiK-Obround", "Settings", "Vertical", False)
        If optVertical.Value <> True And optHorizontal.Value <> True Then
            optAngle.Value = True
        End If
    
End Sub


Public Sub Obround()

    Dim odoc As Document
    Dim oSketch As PlanarSketch

    On Error Resume Next
    Set odoc = ThisApplication.ActiveDocument
If odoc.DocumentType <> kPartDocumentObject And _
odoc.DocumentSubType.DocumentSubTypeID <> "{28EC8354-9024-440F-A8A2-0E0E55D635B0}" Then
        MsgBox "Must be in Part document"
        Exit Sub
    End If
    
    Set oSketch = ThisApplication.ActiveEditObject
    If Err Then
        MsgBox "MUST BE IN ACTIVE SKETCH TO RUN!"
        Exit Sub
    End If

    frmObround.Show
frmObround.Top = GetSetting("KWiK-Obround", "Settings", "Top", "200")
frmObround.Left = GetSetting("KWiK-Obround", "Settings", "Left", "100")


End Sub
